unit MyTaskPane;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, MyAddin1_TLB, MyAddin1_IMPL, StdVcl,
  StdCtrls, Outlook2000;

type
  TMyTaskPane = class(TActiveForm, IMyTaskPane)
    Label1: TLabel;
  private
    FEvents: IMyTaskPaneEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
    procedure WMMouseActivate(var Message: TWMMouseActivate); message WM_MOUSEACTIVATE;
  protected
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: Integer; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: Integer); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;

    function Get_InfoString: WideString; safecall;
    procedure Set_InfoString(const Value: WideString); safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_ScreenSnap: WordBool; safecall;
    function Get_SnapBuffer: Integer; safecall;
    procedure Set_ScreenSnap(Value: WordBool); safecall;
    procedure Set_SnapBuffer(Value: Integer); safecall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
    //User Procedure
  end;

implementation

uses ComObj, ComServ;

{$R *.DFM}

{ TAdxTaskPain1 }

procedure TMyTaskPane.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_MyTaskPane); }
end;

procedure TMyTaskPane.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IMyTaskPaneEvents;
end;

procedure TMyTaskPane.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
end;

function TMyTaskPane.Get_Active: WordBool;
begin
  Result := Active;
end;

function TMyTaskPane.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TMyTaskPane.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TMyTaskPane.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TMyTaskPane.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TMyTaskPane.Get_Color: Integer;
begin
  Result := Integer(Color);
end;

function TMyTaskPane.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TMyTaskPane.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TMyTaskPane.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TMyTaskPane.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TMyTaskPane.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TMyTaskPane.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TMyTaskPane.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TMyTaskPane.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TMyTaskPane.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TMyTaskPane.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TMyTaskPane.Get_VisibleDockClientCount: Integer;
begin
  Result := VisibleDockClientCount;
end;

procedure TMyTaskPane.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TMyTaskPane.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TMyTaskPane.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TMyTaskPane.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TMyTaskPane.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TMyTaskPane.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TMyTaskPane.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TMyTaskPane.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

procedure TMyTaskPane.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TMyTaskPane.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TMyTaskPane.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TMyTaskPane.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TMyTaskPane.Set_Color(Value: Integer);
begin
  Color := TColor(Value);
end;

procedure TMyTaskPane.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TMyTaskPane.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TMyTaskPane.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TMyTaskPane.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TMyTaskPane.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TMyTaskPane.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TMyTaskPane.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TMyTaskPane.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TMyTaskPane.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TMyTaskPane.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

destructor TMyTaskPane.Destroy;
var
  ParkingHandle: HWND;
begin
  ParkingHandle := FindWindowEx(0, 0, 'DAXParkingWindow', nil);
  if ParkingHandle <> 0 then
    SendMessage(ParkingHandle, WM_CLOSE, 0, 0);
  inherited Destroy;
end;

function SearchForHWND(const AControl: TWinControl; Focused: HWND): boolean;
var
  i: Integer;
begin
  Result := (AControl.Handle = Focused);
  if not Result then
    for i := 0 to AControl.ControlCount - 1 do
      if AControl.Controls[i] is TWinControl then begin
        if TWinControl(AControl.Controls[i]).Handle = Focused then begin
          Result := True;
          Break;
        end
        else
          if TWinControl(AControl.Controls[i]).ControlCount > 0 then begin
            Result := SearchForHWND(TWinControl(AControl.Controls[i]), Focused);
            if Result then Break;
          end;
      end;
end;

procedure TMyTaskPane.WMMouseActivate(var Message: TWMMouseActivate);
var
  FocusedWindow: HWND;
  CursorPos: TPoint;
begin
  inherited;
  FocusedWindow := Windows.GetFocus;
  if not SearchForHWND(Self, FocusedWindow) then begin
    Windows.GetCursorPos(CursorPos);
    FocusedWindow := WindowFromPoint(CursorPos);
    Windows.SetFocus(FocusedWindow);
    Message.Result := MA_ACTIVATE;
  end;
end;
// User

function TMyTaskPane.Get_InfoString: WideString;
begin
  Result :=  Label1.Caption;
end;

procedure TMyTaskPane.Set_InfoString(const Value: WideString);
begin
  if  Label1.Caption <> Value  then
    Label1.Caption := Value;
end;

function TMyTaskPane.Get_AlignDisabled: WordBool;
begin
  Result := AlignDisabled;
end;

function TMyTaskPane.Get_ScreenSnap: WordBool;
begin
  Result := ScreenSnap;
end;

function TMyTaskPane.Get_SnapBuffer: Integer;
begin
  Result := SnapBuffer;
end;

procedure TMyTaskPane.Set_ScreenSnap(Value: WordBool);
begin
  ScreenSnap := Value;
end;

procedure TMyTaskPane.Set_SnapBuffer(Value: Integer);
begin
  SnapBuffer := Value;
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TMyTaskPane,
    Class_MyTaskPane,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
